package com.bbc.denadrive.apihandlers

import androidx.compose.runtime.MutableState
import androidx.compose.runtime.mutableStateOf
import androidx.lifecycle.ViewModel
import kotlinx.serialization.SerializationException
import kotlinx.serialization.json.Json

class ResponsesHandler: ViewModel() {

    val lastResponseBody: MutableState<DriveResponseBody?> = mutableStateOf(null)

    private var lastResponse: String = ""
    private var isComplete: Boolean = true
    private lateinit var respBuilder: StringBuilder

    fun newResponseArrived(response: String?) {
        if (isComplete && response != null) {
            respBuilder = StringBuilder(response)
            updateCompleteness()
        }
        else if (response != null) {
            respBuilder.append(response)
            updateCompleteness()
        }
    }

    private fun checkForCompleteness(): Pair<Boolean, DriveResponseBody?> {
        return try {
            Pair(true, Json.decodeFromString<DriveResponseBody>(respBuilder.toString()))
        } catch (e: SerializationException) {
            Pair(false, null)
        }
    }

    private fun updateCompleteness() {
        val pair = checkForCompleteness()
        isComplete = pair.first
        if (isComplete) {
            lastResponse = respBuilder.toString()
            lastResponseBody.value = pair.second
        }
    }

}